local M = {}
  gdscenarios = require("gdscenarios")
  gdcallback = require('gdcallback')
local function onPreRender(dt,dtSim)
	gdscenarios.updateGFX(dt,dtSim)
end
local function onVehicleSpawned(vehicleID)
	if scenario_gdheats and scenario_gdstats then
		scenario_gdheats.onVehicleSpawned(vehicleID)
		scenario_gdstats.onVehicleSpawned(vehicleID)
	end
end
local function onScenarioChange(sc)
	gdscenarios.onScenarioChange(sc)
end
local function onPhysicsPaused()
	gdscenarios.onPhysicsPaused()
end
local function onPhysicsUnpaused()
	gdscenarios.onPhysicsUnpaused()
end
local function onCountdownEnded()
	gdscenarios.onCountdownEnded()
end
local function onCountdownStarted()
	gdscenarios.onCountdownStarted()
end
local function onScenarioRestarted()
	gdscenarios.onScenarioRestarted()
end
local function onVehicleDestroyed(vid)
	gdscenarios.onVehicleDestroyed(vid)
end
local function loadgdscenario()
	extensions.load('scenario_gdscenariosLoader')
	if scenario_gdscenariosLoader then
		scenario_gdscenariosLoader.scenarioStart(1)
	end
end
local function onScenarioUIReady(state)
	--gdscenarios.onScenarioUIReady(state)
end
local function onClientStartMission(mission)
	gdscenarios.onClientStartMission(mission)
end
local function onRaceTick()
	gdscenarios.onRaceTick()
end
--local function onObjectCollision(vehicleID, otherObjID)
--	if scenario_gdstats then
	--	scenario_gdstats.onObjectCollision(vehicleID, otherObjID)
	--end
--end

--M.onObjectCollision = onObjectCollision
M.onRaceTick = onRaceTick
M.loadgdscenario = loadgdscenario
M.onVehicleDestroyed = onVehicleDestroyed
--M.onFreeroamLoaded = onFreeroamLoaded
M.onVehicleSpawned = onVehicleSpawned
M.onPreRender = onPreRender
M.onCountdownEnded = onCountdownEnded
M.onCountdownStarted = onCountdownStarted
M.onScenarioChange = onScenarioChange
M.onPhysicsPaused = onPhysicsPaused
M.onPhysicsUnpaused = onPhysicsUnpaused
M.onPhysicsPaused = onPhysicsPaused
M.onScenarioRestarted = onScenarioRestarted
M.onScenarioUIReady = onScenarioUIReady
M.onClientStartMission = onClientStartMission
return M