angular.module('beamng.apps')
/**
 * @ngdoc directive
 * @name beamng.apps:derbyInfo
 * @description 
**/
.directive('derbyInfo', function () {  
    return {
	templateUrl: 'modules/apps/DerbyInfo/app.html',
    replace: true,
	scope: true,
    link: function (scope, element, attrs) {
      scope.stats = null;
	  scope.theaders = null;
	  scope.tsorting = 'place';
      scope.$on('DerbyInfoUpdate', function (event, data) {
       // console.log('Testing to see if we get Data');
	
        scope.$applyAsync(function () {
			if(data.theaders !== undefined){
			scope.theaders = data.theaders;
			scope.tstats = data.tstats;
			scope.tsorting = data.order;
			};
        });
      });
      scope.$on('ScenarioNotRunning', function () {
        scope.tstats = null;
		scope.theaders = null;
      });
    }
  };
});