angular.module('beamng.apps')
/**
 * @ngdoc directive
 * @name beamng.apps:derbyStats
 * @description 
**/
.directive('derbyStats', function () {  
    return {
	templateUrl: 'modules/apps/DerbyStats/app.html',
    replace: true,
	scope: true,
    link: function (scope, element, attrs) {
      scope.stats = null;
	  scope.statheaders = null;
	  scope.sorting = 'place';
      scope.$on('DerbyStatsUpdate', function (event, data) {
       // console.log('Testing to see if we get Data');
	
        scope.$applyAsync(function () {
			if(data.statheaders !== undefined){
			scope.statheaders = data.statheaders;
			scope.stats = data.stats;
			scope.sorting = data.order;
			};
        });
      });
      scope.$on('ScenarioNotRunning', function () {
        scope.stats = null;
		scope.statheaders = null;
      });
    }
  };
});